/*
 *	main.c
 *
 *	3Dr[A
 *
 *	* Mon Jul 03 20:44:49 JST 2006 Naoyuki Sawa
 *	- 1st [XB
 *	* Tue Jul 04 06:05:47 JST 2006 Naoyuki Sawa
 *	- eNX`ǂݍݑΉB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

#ifdef USE_MUSIC
#include "instdef2.c"
#endif /*USE_MUSIC*/

#ifdef USE_TEXTURE
TEXTURE texture_table[TEXTURE_COUNT];
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
#define SPRITE_ SPRITE_INIT2
const SPRITE sprite_table[SPRITE_COUNT] = {
#include "sprite.h"
};
#undef SPRITE_
#endif /*USE_SPRITE*/

#define extern
#include "work.h"
#undef extern

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* CB */
	app_main();

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceAppSetProcPeriod(1000 / FPS);
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceLCDDispStart();
#ifdef QUICK_REPEAT
	pcePadSetTrigMode(PP_MODE_SINGLE);
#endif /*QUICK_REPEAT*/

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
#ifdef USE_3D
	surface.zbuff = zbuff;
	render_init_3d(&render, &surface, 0, 0, 0, 0, FRONT, BACK, FOVY);
#else /*USE_3D*/
	render_init_2d(&render, &surface, 0, 0, 0, 0);
#endif /*USE_3D*/

#if defined(TRACE_ON) && (TRACE_ON)
	/* WG[o͂J܂B */
	stderr_open(9/*WG[o̓j^ڑ҂()*/);
#endif /*TRACE_ON*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VJn܂B */
	ufe_setup(9/*PCt@CT[oڑ҂()*/);
#endif /*USE_UFE*/

#ifdef TURBO
	/* NbNEEFCgؑւ܂B */
	turbo(TURBO);
#endif /*TURBO*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_init();
#endif /*USE_GC*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gJn܂B */
	tcpip_start(0/*EthernethCoMobt@TCY()*/);
#endif /*USE_TCPIP*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_init(LDIRECT_INTERVAL);
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_MUSIC
	/* yCu܂B */
	music_loudness(1);
	loadInst(); /* uRandomism Zone(http://www8.plala.or.jp/randomism/)v́whFLbgver.2.10xgp */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

	/* eNX`܂B */
#ifdef USE_TEXTURE
	{
#define TEXTURE_(name) extern const unsigned char name[];
#include "texture.h"
#undef TEXTURE_
		texture_table_init(texture_table, TEXTURE_COUNT,
#define TEXTURE_(name) name,
#include "texture.h"
#undef TEXTURE_
		NULL/*Ō','z邽߂̃_~[Btexture_table_init()ɑ΂Ă͖ӖłB*/);
	}
#endif /*USE_TEXTURE*/

#ifdef USE_SPRITE
	/* ȈՃXvCghCo܂B */
	sprite_init(&render, sprite_table, SPRITE_COUNT, texture_table, TEXTURE_COUNT);
#endif /*USE_SPRITE*/

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
	music_loudness(0);
#endif /*USE_MUSIC*/

#ifdef LDIRECT_INTERVAL
	/* ؑցE16K\܂B */
	ldirect_free();
#endif /*LDIRECT_INTERVAL*/

#ifdef USE_TCPIP
	/* TCP/IPvgRXC[gI܂B */
	tcpip_stop();
#endif /*USE_TCPIP*/

#ifdef USE_GC
	/* K[x[WRN^[܂B */
	gc_free();
#endif /*USE_GC*/

#ifdef USE_UFE
	/* USBt@CVXeG~[VI܂B */
	ufe_stop();
#endif /*USE_UFE*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	int x __attribute__((unused));
	int y __attribute__((unused));

#ifdef USE_PAUSE
	{
		/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
		 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
		 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
		 */
		//unsigned char save[PAUSE_H][PAUSE_W];
		unsigned char (*save)[PAUSE_W] = NULL/*x}*/;
		int pause = 0;
		for(;;) {
#endif /*USE_PAUSE*/

#ifdef V_SCREEN
			{ /* vbuff(c)_def_vbuff()ϊ */
				unsigned char *dst, *src;
				dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
				src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
				for(x = DISP_X - 1; x >= 0; x--) {
					for(y = 0; y < DISP_Y; y++) {
						*dst = *src;
						dst += 1;      /* ʂEɑ܂ */
						src += DISP_X; /* cʂɑ܂ */
					}
					                            /* ʂ͊Ɏ̍sֈړĂ܂ */
					src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
				}
			}
#endif /*V_SCREEN*/
			pceLCDTrans();		/* ʍXV */
			yield();		/* VXe */
			joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
			joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
				       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
				| (joy & PAD_LF ? PAD_UP : 0)
				| (joy & PAD_RI ? PAD_DN : 0)
				| (joy & PAD_UP ? PAD_RI : 0)
				| (joy & PAD_DN ? PAD_LF : 0)
				| (joy & TRG_LF ? TRG_UP : 0)
				| (joy & TRG_RI ? TRG_DN : 0)
				| (joy & TRG_UP ? TRG_RI : 0)
				| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

#ifdef USE_PAUSE
			/* PAUSEB */
			if(joy & TRG_START) {
				pause = !pause;	/* PAUSEԐ؂ւ */
				if(pause) {	/* PAUSE IN */
					/* PAUSEbZ[W\̃C[WޔB */
					save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
					if(save == NULL) DIE();
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
						}
					}
				} else {	/* PAUSE OUT */
					/* PAUSEbZ[W\̃C[W𕜋AB */
					for(y = 0; y < PAUSE_H; y++) {
						for(x = 0; x < PAUSE_W; x++) {
							vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
						}
					}
					free(save); /* C[Wޔpobt@J */
				}
			}
			if(!pause) break;

			/* PAUSEbZ[W_ŕ\B */
			if(pceTimerGetCount() % 1000 < 750) {
				render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
			} else {
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
			}
		}
	}
#endif /*USE_PAUSE */

#ifdef QUICK_REPEAT
	/* I[gs[gB */
	{
		static unsigned char rep[8]; /* I[gs[gJE^ */
		int i, mask;
		for(i = 0; i < 8; i++) {
			mask = 1 << i; /* PAD_* */
			if(QUICK_REPEAT_PADS & mask) {
				if(joy & mask) {
					if(rep[i] != 0xff) rep[i]++;
					if(rep[i] >= QUICK_REPEAT_DELAY) joy |= mask << 8; /* TRG_* */
				} else {
					rep[i] = 0;
				}
			}
		}
	}
#endif QUICK_REPEAT

	now++;	/* O[o^C}XV */

	/* SELECT{^ꂽAłɏI܂B */
	if(joy & TRG_SELECT) {
		exit(0);
	}
}

/****************************************************************************
 *	delay
 ****************************************************************************/

void
delay(int frame)
{
	while(frame > 0) {
		schedule();
		frame--;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

/* t@C^Cv𔻒f܂B
 * [in]
 *	fname		t@CB
 * [out]
 *	߂l		t@C^CvB
 *			0 = s
 *			1 = Mesh
 *			2 = Wire
 */
static int
file_type(const char* fname)
{
	int type = 0;
	//
	int retval;
	FILEACC fa;
	const unsigned char* ptr;
	int size;
	int i;

	/* t@CJ܂B */
	retval = pceFileOpen(&fa, fname, FOMD_RD);
	if(retval != 0) {
		DIE();
	}

	/* 擪ZN^̃AhX擾܂B */
	pceFileReadSct(&fa, NULL, 0, BLOCKSIZE);
	ptr = fa.aptr;

	/* TCY肵܂B
	 * t@CTCYZN^TCYȏȂ΁A擪ZN^̂݌܂B
	 * t@CTCYZN^TCYȂ΁At@CŜ܂B
	 */
	size = fa.fsize;
	if(size > BLOCKSIZE) {
		size = BLOCKSIZE;
	}

	/* "<mesh`>"^OLMeshA"<wire`>"^OLWireƔf܂B */
	for(i = 0; i < size - 5; i++) {
		if(!strncasecmp(ptr + i, "<mesh", 5)) {
			type = 1; /* Mesh */
			break;
		}
		if(!strncasecmp(ptr + i, "<wire", 5)) {
			type = 2; /* Wire */
			break;
		}
	}

	/*t@C܂B */
	pceFileClose(&fa);

	return type;
}

/****************************************************************************
 *	
 ****************************************************************************/

static void
menu_init()
{
	static const MENUPALETTE pal = {
		item   : 0,
		back   : 3,
		title  : 3,
		border : 1,
	};
	//
	int type;
	FILEINFO fi;

	menu = menu_create();
	menu_set_title(menu, "Files");
	menu_set_font(menu, 2);
	menu_set_palette(menu, &pal);

	pceFileFindOpen(&fi);
	while(pceFileFindNext(&fi)) {
		type = file_type(fi.filename);
		if(type) {
			menu_add_item(menu, fi.filename);
		}
	}
	pceFileFindClose(&fi);

	if(!menu_num_items(menu)) {
		//   0123456789012345678901234
		die("ү/ܲ԰̧قL܂");
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static void
model_disp()
{
#define T (render.context->matrix)

#if 0
	surface_clear(&surface, 0);
#else
	clear();
#endif

	render_save(&render);

		T = mlookat(T,
			eye_x, eye_y, eye_z,
			eye_x, eye_y,     0,
			eye_bank);

		T = mxform(T, Trot);
		T = mfscale(T, scale);

		if(mesh) {
			render_mesh(&render, mesh);
		}
		if(wire) {
			render_wire(&render, wire, 0);
		}

	render_restore(&render);

	sprite_draw(4, DISP_Y - 4, SPR_MODE0 + mode, DRW_NOMAL);

#undef T
}

/****************************************************************************
 *	
 ****************************************************************************/

static void
model_action()
{
	matrix m;
	vector v1;
	vector v2;
	vector v3;

	if(joy & TRG_A) {
		mode = (mode + 1) % 4;
	}

	if(joy & (PAD_LF | PAD_RI | PAD_UP | PAD_DN)) {
		m = MATRIX_I;
		switch(mode) {
		case 0:
			if(joy & PAD_LF) m = mroty(MATRIX_I,      ROT_SPD );
			if(joy & PAD_RI) m = mroty(MATRIX_I, fchs(ROT_SPD));
			if(joy & PAD_UP) m = mrotx(MATRIX_I,      ROT_SPD );
			if(joy & PAD_DN) m = mrotx(MATRIX_I, fchs(ROT_SPD));
			break;
		case 1:
			if(joy & PAD_LF) m = mrotz(MATRIX_I,      ROT_SPD );
			if(joy & PAD_RI) m = mrotz(MATRIX_I, fchs(ROT_SPD));
			if(joy & PAD_UP) m = mrotx(MATRIX_I,      ROT_SPD );
			if(joy & PAD_DN) m = mrotx(MATRIX_I, fchs(ROT_SPD));
			break;
		case 2:
			if(joy & PAD_UP) eye_z = fsub(eye_z, MOVE_SPD);
			if(joy & PAD_DN) eye_z = fadd(eye_z, MOVE_SPD);
			if(joy & PAD_LF) eye_x = fadd(eye_x, MOVE_SPD);
			if(joy & PAD_RI) eye_x = fsub(eye_x, MOVE_SPD);
			break;
		case 3:
			if(joy & PAD_UP) eye_y = fsub(eye_y, MOVE_SPD);
			if(joy & PAD_DN) eye_y = fadd(eye_y, MOVE_SPD);
			if(joy & PAD_LF) eye_x = fadd(eye_x, MOVE_SPD);
			if(joy & PAD_RI) eye_x = fsub(eye_x, MOVE_SPD);
			break;
		default:
			DIE();
		}
		Trot = mxform(m, Trot);

		v1.x = Trot.a00; v1.y = Trot.a10; v1.z = Trot.a20;
		v2.x = Trot.a01; v2.y = Trot.a11; v2.z = Trot.a21;
		v3.x = Trot.a02; v3.y = Trot.a12; v3.z = Trot.a22;
		v1 = vnormal(vcross(v2, v3));
		v2 = vnormal(vcross(v3, v1));
		v3 = vnormal(vcross(v1, v2));
		Trot.a00 = v1.x; Trot.a10 = v1.y; Trot.a20 = v1.z;
		Trot.a01 = v2.x; Trot.a11 = v2.y; Trot.a21 = v2.z;
		Trot.a02 = v3.x; Trot.a12 = v3.y; Trot.a22 = v3.z;
	}
}

/****************************************************************************
 *	
 ****************************************************************************/

static fixed
get_size(const vector* v, int nv)
{
	int i;
	fixed s;
	fixed t;
	fixed x_min = 0;
	fixed x_max = 0;
	fixed y_min = 0;
	fixed y_max = 0;
	fixed z_min = 0;
	fixed z_max = 0;

	for(i = 0; i < nv; i++) {
		if(fcom(v->x, <, x_min)) x_min = v->x;
		if(fcom(v->x, >, x_max)) x_max = v->x;
		if(fcom(v->y, <, y_min)) y_min = v->y;
		if(fcom(v->y, >, y_max)) y_max = v->y;
		if(fcom(v->z, <, z_min)) z_min = v->z;
		if(fcom(v->z, >, z_max)) z_max = v->z;
		v++;
	}

	t = fsub(x_max, x_min);                   s = t;
	t = fsub(y_max, y_min); if(fcom(t, >, s)) s = t;
	t = fsub(z_max, z_min); if(fcom(t, >, s)) s = t;

	return s;
}

static void
model_load()
{
	int sel;
	int type;
	fixed size;
	char fname[MAXFILENAME + 1];
	FILE* fp;
	int len;

	/* [hɎԂꍇ̂ŁA"Now Loading..."\܂B */
	model_disp();
	menu_disp(menu, &render);
	render_string_framed(&render, DISP_X - 60, DISP_Y - 12, "Now Loading...", 0x82, 0x003);
	schedule();

	/* ̃bVAC[t[AeNX`J܂B */
	if(mesh) {
		free(mesh);
		mesh = NULL;
	}
	if(wire) {
		free(wire);
		wire = NULL;
	}
	if(texture_data) {
		free(texture_data);
		texture_data = NULL;
		render.context->texture = NULL; /* YȂ!! */
	}

	/* bVA܂́AC[t[t@C擾܂B */
	sel = menu_get_sel(menu);
	menu_get_item(menu, sel, fname, sizeof fname);

	/* bVA܂́AC[t[[h܂B */
	type = file_type(fname);
	switch(type) {
	case 1:
		mesh = mesh_load(fname);
		size = get_size((const vector*)(mesh + 1), mesh->nv);
		break;
	case 2:
		wire = wire_load(fname);
		size = get_size((const vector*)(wire + 1), wire->nv);
		break;
	default:
		DIE();
	}

	/* eNX`t@CL΃[hA`ReLXgɐݒ肵܂B */
	if(mesh) { /* bV̏ꍇ̂ */
		strtok(fname, ".");
		strcat(fname, ".pgd");
		fp = fopen(fname, "rb");
		if(fp) {
			fseek(fp, 0, SEEK_END);
			len = ftell(fp);
			rewind(fp);
			texture_data = malloc(len);
			if(!texture_data) {
				DIE();
			}
			fread(texture_data, 1, len, fp);
			fclose(fp);
			render.context->texture = texture_init(&texture, texture_data);
		}
	}

	/* 샂[hA]A_Agk܂B */
	mode     = 0;
	Trot     = MATRIX_I;
	eye_x    = fld( 0);
	eye_y    = fld( 0);
	eye_z    = fld(-2);
	eye_bank = fld( 0);
	scale = fld(1.0); /*  */
	if(size) {
		scale = fdiv(scale, size);
	}
}

/****************************************************************************
 *	app_main
 ****************************************************************************/

void
app_main()
{
	int size;

	menu_init();

	for(;;) {
		/* j[oB */
		for(size = 1; size < MENU_SIZE; size += 10) {
			schedule();
			model_disp();
			menu_set_pos(menu, MENU_X, MENU_Y, size, size);
			menu_disp(menu, &render);
		}
		menu_set_pos(menu, MENU_X, MENU_Y, MENU_SIZE, MENU_SIZE);

		/* j[IB */
		for(;;) {
			schedule();
			/*{{LZɑIύXȂ悤Amenu_action()̊@\͎gȂ*/
			if(joy & TRG_A) {
				model_load();
				break;
			}
			if(joy & TRG_B) {
				if(mesh || wire) {
					break;
				}
			}
			/*}}LZɑIύXȂ悤Amenu_action()̊@\͎gȂ*/
			menu_action(menu, joy & ~TRG_B);
			menu_disp(menu, &render);
		}

		/* j[B */
		for(size = MENU_SIZE; size > 0; size -= 10) {
			schedule();
			model_disp();
			menu_set_pos(menu, MENU_X, MENU_Y, size, size);
			menu_disp(menu, &render);
		}
		menu_set_pos(menu, 0, 0, MENU_SIZE, MENU_SIZE);

		/* fB */
		for(;;) {
			schedule();
			model_action();
			model_disp();
			if(joy & TRG_B) {
				break;
			}
		}
	}

	//menu_delete(menu);
	//menu = NULL;
	//if(mesh) {
	//	free(mesh);
	//	mesh = NULL;
	//}
	//if(wire) {
	//	free(wire);
	//	wire = NULL;
	//}
	//for͖[vȂ̂ŁAւ͗܂B
}
